# -*- coding: utf-8 -*-
"""
(c)2014 ЗАО "РИПАС"
www.ripas.ru
"""

def rpcObjectConnected(obj):
    import sys
    object_code_string='class '+obj.property('className')+':\n\tdef __init__(self,obj): self.rpc=obj\n'
    import re
    pattern=re.compile('[ (,)]')
    method_list=obj.methodList
    for signature in method_list:
        sig_list=list(filter(None,pattern.split(signature)))
        if len(sig_list)<2:
            continue
        arg_count=len(sig_list[2:])
        arg_list=''
        for i in range(0,arg_count):
            if i>0: arg_list+=','
            arg_list+='%s_%d'%(sig_list[2+i],i+1)
        arg_list=arg_list.replace('::','_').replace('*','')
        object_code_string+='\tdef '+sig_list[1]+'(self,'
        object_code_string+=arg_list
        object_code_string+='):\n\t\t"""'+sig_list[1]+'('+arg_list+')\n\t\t"""\n\t\t'
        if sig_list[0]!='void':
            object_code_string+='return ';
        if len(sig_list)==2:
            object_code_string+='self.rpc.invoke("%s")\n'%sig_list[1]
        else:
            object_code_string+='self.rpc.invoke("%s",(%s,))\n'%(sig_list[1],arg_list)
    compiled_code=compile(object_code_string,'<string>','exec')
    exec(compiled_code,globals())
    cur_moudle=sys.modules[__name__]
    RpcClass=getattr(cur_moudle,obj.property('className'))
    setattr(cur_moudle,obj.objectName,RpcClass(obj))

def rpcObjectDisonnected(obj):
    import sys
    cur_moudle=sys.modules[__name__]
    if hasattr(cur_moudle,obj.objectName):
        delattr(cur_moudle,obj.objectName)
    if hasattr(cur_moudle,obj.property('className')):
        delattr(cur_moudle,obj.property('className'))
